#include "lcd_lib.h"
#include "ir_rcv.h"
#include "print_lib.h"

#define LED		RB0

__CONFIG(INTIO & WDTDIS & PWRTEN & MCLREN & BORDIS & LVPDIS);

void main(void)
{
	int i;
	OSCCON = 0x60;	// 4MHz
	ANSEL = 0;		// デジタルI/O
	TRISA = 0x00;	// Aポート全部出力
	TRISB = 0x02;	// Bポート1のみ入力
	
	// LEDチカチカ
	for (i = 0; i < 3; i++) {
		LED = 0;
		__delay_ms(100);
		LED = 1;
		__delay_ms(100);
	}
	
	lcd_init();
	lcd_goto(0, 0);
	lcd_str("LCD Library");
	lcd_goto(1, 0);
	lcd_str("Initialize OK");

	// LEDチカチカ
	for (i = 0; i < 2; i++) {
		int j;
		LED = 0;
		for (j = 0; j < 10; j++) {
			__delay_ms(100);
		}
		LED = 1;
		for (j = 0; j < 10; j++) {
			__delay_ms(100);
		}
	}
	
	while (1) {
		lcd_clear();
		lcd_str("Waitting Remote...");
		
		WAIT_L;
#if 0
		while (IRRCV != 0) {	// L待ち
		}
#endif
		ir_rcv();
	}

#if 0
	lcd_clear();
	lcd_str("Recive Remote...");
    while (1) {
        LED = 0;
        while (IRRCV==0) {
        }
        LED = 1;
        while (IRRCV!=0) {
        }
    }
#endif
}
