//
// print_lib.c
//
// sizeof(int) == 2
// sizeof(long) == 4
#include "print_lib.h"

int strlen(const char *str)
{
	int res = 0;
	while (str[res] != 0) {
		res++;
	}
	return res;
}

void strrvrs(char *str)
{
	int len = strlen(str) - 1;
	int i = 0;
	while (i < len) {
		char tmp = str[i];
		str[i] = str[len];
		str[len] = tmp;
		i++;
		len--;
	}
}

void sprint_int(char *buff, int value)
{
	int v = value;
	int i = 0;
	if (v == 0) {
		buff[0] = '0';
		buff[1] = 0;
	} else {
		if (v < 0) {
			v = -v;
		}
		while (v != 0) {
			buff[i++] = '0' + (v % 10);
			v = v / 10;
			buff[i] = 0;
		}
		if (value < 0) {
			buff[i++] = '-';
			buff[i] = 0;
		}
		strrvrs(buff);
	}
}

void sprint_hex_char(char *buff, char value)
{
	int v;
	int shift = 4;
	int i = 0;
	for (i = 0; i < 2; i++) {
		v = (value >> shift) & 0x0F;
		char c;
		if (v < 10) {
			c = '0' + v;
		} else {
			c = 'A' + v - 10;
		}
		buff[i] = c;
		buff[i+1] = 0;
		shift -= 4;
	}
}

void sprint_hex_int(char *buff, int value)
{
	int v;
	int shift = 12;
	int i = 0;
	for (i = 0; i < 4; i++) {
		v = (value >> shift) & 0x0F;
		char c;
		if (v < 10) {
			c = '0' + v;
		} else {
			c = 'A' + v - 10;
		}
		buff[i] = c;
		buff[i+1] = 0;
		shift -= 4;
	}
}

void print_int(const char *label, int value)
{
	char tmp[8];
	sprint_int(tmp, value);
	if (label != NULL) {
		lcd_str(label);
	}
	lcd_str(tmp);
}

void print_hex_char(const char *label, char value)
{
	char tmp[4];
	sprint_hex_char(tmp, value);
	if (label != NULL) {
		lcd_str(label);
	}
	lcd_str(tmp);
}

void print_hex_int(const char *label, int value)
{
	char tmp[8];
	sprint_hex_int(tmp, value);
	if (label != NULL) {
		lcd_str(label);
	}
	lcd_str(tmp);
}
